#include <pic.h>
#include "LedDriver.h"
// Led matrix dirver
#define     CP1             1
#define     CP2             2
#define     CP3             4
#define     CP4             8
#define     CP5             16
#define     CP6             32
#define     CP7             64
#define     CP8             128
#define     CP9             (4<<8)
#define     CP10            (8<<8)
#define     CP11            (16<<8)
#define     CP12            (32<<8)

#define     LED_MASK        (CP1|CP2|CP3|CP4|CP5|CP6|CP7|CP8|CP9|CP10|CP11|CP12)
#define     SetP1Dir(x)     TRISC = (x)
#define     SetP2Dir(x)     TRISA = (x)
#define     LED_PORT1       PORTC
#define     LED_PORT2       PORTA

const unsigned short Connection[] =
{
    0,CP1,CP2,CP3,CP4,CP5,CP6,CP7,CP8,CP9,CP10,CP11,CP12
};

const unsigned char LightTable[] = 
{
    0x12,0x13,0x14,0x15,0x16,0x17,0x18,0x19,0x1a,0x1b,0x1c,
    0x23,0x24,0x25,0x26,0x27,0x28,0x29,0x2a,0x2b,0x2c,
    0x34,0x35,0x36,0x37,0x38,0x39,0x3a,0x3b,0x3c,
    0x45,0x46,0x47,0x48,0x49,0x4a,0x4b,0x4c,
    0x56,0x57,0x58,0x59,0x5a,0x5b,0x5c,
    0x67,0x68,0x69,0x6a,0x6b,0x6c,
    0x78,0x79,0x7a,0x7b,0x7c,
    0x89,0x8a,0x8b,0x8c,
    0x9a,0x9b,0x9c,
    0xab,0xac,
    0xbc
};

// Zero based led index
unsigned char  index;
unsigned short  type,type0,type1;
unsigned char  ledPort1;
unsigned char  ledPort2;
unsigned char  IOs;

// Turn on the specify led
void    TurnOnLed(unsigned char ledIndex)
{
    index = ledIndex>>1;
    IOs = LightTable[index];
    type0 = Connection[IOs&0xF];
    type1 = Connection[IOs>>4];
    type = type0 | type1;
    ledPort1 = (unsigned char)(LED_MASK ^ type);
    ledPort2 = (unsigned char)((LED_MASK ^ type)>>8);
    SetP1Dir(ledPort1);
    SetP2Dir(ledPort2);
    if(ledIndex&1){
        LED_PORT1 = (unsigned char)type0;
        LED_PORT2 = (unsigned char)(type0>>8);
    }else{
        LED_PORT1 = (unsigned char)type1;
        LED_PORT2 = (unsigned char)(type1>>8);
    }
}

DisplayData     dispBuffer[10];
void    FormatSecond(unsigned char ledIndex)
{
    index = ledIndex>>1;
    IOs = LightTable[index];
    type0 = Connection[IOs&0xF];
    type1 = Connection[IOs>>4];
    dispSecond.dirData = LED_MASK ^ (type0 | type1);
    if(ledIndex&1){
        dispSecond.ioData = type0;
    }else{
        dispSecond.ioData = type1;
    }
}
void    FormatMinute(unsigned char ledIndex)
{
    ledIndex+=60;
    index = ledIndex>>1;
    IOs = LightTable[index];
    type0 = Connection[IOs&0xF];
    type1 = Connection[IOs>>4];
    dispMinute.dirData = LED_MASK ^ (type0 | type1);
    if(ledIndex&1){
        dispMinute.ioData = type0;
    }else{
        dispMinute.ioData = type1;
    }
}
void    FormatHour(unsigned char ledIndex)
{
    ledIndex+=120;
    index = ledIndex>>1;
    IOs = LightTable[index];
    type0 = Connection[IOs&0xF];
    type1 = Connection[IOs>>4];
    dispHour.dirData = LED_MASK ^ (type0 | type1);
    if(ledIndex&1){
        dispHour.ioData = type0;
    }else{
        dispHour.ioData = type1;
    }
}
